/*
 * Copyright (c) 1992, 1996
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef lint
static  char rcsid[] =
    "@(#)$Header: util.c,v 1.5 96/07/04 19:27:11 leres Exp $ (LBL)";
#endif

#include <sys/types.h>

#include <stdio.h>

#include "gpstime.h"
#include "util.h"


u_char
cksum(cp, n)
	register char *cp;
	register u_int n;
{
	register u_char ck;

	for (ck = 0; n-- > 0; ++cp)
		ck ^= *cp;
	return (ck);
}

void
viswrite(str, n)
	register char *str;
	register u_int n;
{
	register char c;

	while (n-- > 0) {
		c = *str++;
		if (c & ~ 0177) {
			(void)fputs("M-", stderr);
			c &= 0177;
		}
		if (c >= 0x20 && c != 0177) {
			(void)fputc(c, stderr);
			continue;
		}
		if (c == '\0')
			(void)fputs("\\0", stderr);
		else if (c == '\b')
			(void)fputs("\\b", stderr);
		else if (c == '\f')
			(void)fputs("\\f", stderr);
		else if (c == '\n')
			(void)fputs("\\n", stderr);
		else if (c == '\r')
			(void)fputs("\\r", stderr);
		else if (c == '\t')
			(void)fputs("\\t", stderr);
		else if (c == '"')
			(void)fputs("\\\"", stderr);
		else {
			(void)fputc('^', stderr);
			/* DEL to ?, others to alpha */
			(void)fputc(c ^ 0x40, stderr);
		}
	}
}
